// Animate

// Update stage will render next frame
createjs.Ticker.framerate = 30;
createjs.Ticker.addEventListener("tick", tickHandler);

function tickHandler(e) {
	stage.update();
}

function update_diagram(R, L, C) {

	// Get frequency f from config
	var F = config.f_value;	


	// Align diagram
	var diagram_x = config.center_x - 30;
	var diagram_y = config.center_y - 330;


	// Draw R vector

	if (R > 0) {

		arrowR.visible = true;
		Rtext1.visible = true;

		var arrowR_len = Math.abs(70 * R / 50);

		// fix low values
		if (arrowR_len < 20) {
			arrowR_len = 20;
		}

		arrowR.graphics.clear().beginStroke("#009900").setStrokeStyle(5).moveTo(0,0).lineTo(0,-(arrowR_len-12));
		arrowR.graphics.beginFill("#009900").setStrokeStyle(1).moveTo(0,-(arrowR_len-12)).lineTo(10,-(arrowR_len-12)).lineTo(0,-arrowR_len).lineTo(-10,-(arrowR_len-12)).lineTo(0,-(arrowR_len-12));

		arrowR.x = diagram_x + 70;
		arrowR.y = diagram_y + 350;
		arrowR.rotation = 90;
		stage.addChild(arrowR);


		Rtext1.x = diagram_x + 70 + arrowR_len - 16;
		Rtext1.y = diagram_y + 363;

		stage.addChild(Rtext1);

	} else {
		arrowR.visible = false;
		Rtext1.visible = false;
	}

	/*
	var r0text2 = new createjs.Text("0","13px Arial","#009900");
	r0text2.x = diagram_x + 84 + arrowR0_len - 16;
	r0text2.y = diagram_y + 371;
	stage.addChild(r0text2);
	*/


	// Draw XL vector

	var XL;

	if (L > 0) {
		
		arrowL.visible = true;
		Ltext1.visible = true;
		Ltext2.visible = true;

		L = L / 1000;	// We use mH (mH = 10^-3, μΗ = 10^-6, nH = 10^-9, pH = 10^-12)

		XL = 2 * Math.PI * F * L;	

		var arrowL_len = Math.abs(70 * XL / 50);

		// fix low values
		if (arrowL_len < 20) {
			arrowL_len = 20;
		}

		arrowL.graphics.clear().beginStroke("gold").setStrokeStyle(5).moveTo(0,0).lineTo(0,-(arrowL_len-12));
		arrowL.graphics.beginFill("gold").setStrokeStyle(1).moveTo(0,-(arrowL_len-12)).lineTo(10,-(arrowL_len-12)).lineTo(0,-arrowL_len).lineTo(-10,-(arrowL_len-12)).lineTo(0,-(arrowL_len-12));
		arrowL.x = diagram_x + 70;
		arrowL.y = diagram_y + 350;
		stage.addChild(arrowL);

		Ltext1.x = diagram_x + 34;
		Ltext1.y = diagram_y + 325 - arrowL_len;
		stage.addChild(Ltext1);

		Ltext2.x = diagram_x + 50;
		Ltext2.y = diagram_y + 330 - arrowL_len + 9;
		stage.addChild(Ltext2);


	} else {
		XL = 0;

		arrowL.visible = false;
		Ltext1.visible = false;
		Ltext2.visible = false;
	}

	//console.log('XL='+XL);


	// Draw XC vector

	var XC;
	if (C > 0) {

		arrowC.visible = true;
		Ctext1.visible = true;
		Ctext2.visible = true;

		C = C / 1000 / 1000; // We use μF (mF = 10^-3, μF = 10^-6, nF = 10^-9, pF = 10^-12)

		XC = 1 / (2 * Math.PI * F * C);

		var arrowC_len = Math.abs(70 * XC / 50);

		// fix low values
		if (arrowC_len < 20) {
			arrowC_len = 20;
		}

		arrowC.graphics.clear().beginStroke("blue").setStrokeStyle(5).moveTo(0,0).lineTo(0,-(arrowC_len-12));
		arrowC.graphics.beginFill("blue").setStrokeStyle(1).moveTo(0,-(arrowC_len-12)).lineTo(10,-(arrowC_len-12)).lineTo(0,-arrowC_len).lineTo(-10,-(arrowC_len-12)).lineTo(0,-(arrowC_len-12));
		arrowC.x = diagram_x + 70;
		arrowC.y = diagram_y + 350;
		arrowC.rotation = 180; // XC is negative!
		stage.addChild(arrowC);

		Ctext1.x = diagram_x + 39;
		Ctext1.y = diagram_y + 358 + arrowC_len - 6;
		stage.addChild(Ctext1);

		Ctext2.x = diagram_x + 51;
		Ctext2.y = diagram_y + 358 + arrowC_len + 3;
		stage.addChild(Ctext2);

	} else {

		arrowC.visible = false;
		Ctext1.visible = false;
		Ctext2.visible = false;

		XC = 0;
	}

	//console.log('XC='+XC);



	// Draw XL-XC vector
	var LC = XL - XC;

	if ( L>0 && C>0 && (LC>=0.1 || LC<=-0.1) ) {
		// do not show XL-XC arrows in case of L>0, C>0 
		// or XL-XC is lower +/-0.1 to avoid it for very small values.

		arrowLC.visible = true;
		LCtext1.visible = true;
		LCtext2.visible = true;

		var arrowLC_len = Math.abs(70 * LC / 50);

		// fix low values
		if (arrowLC_len < 20) {
			arrowLC_len = 20;
		}

		arrowLC.graphics.clear().beginStroke("purple").setStrokeStyle(5.3).moveTo(0,0).lineTo(0,-(arrowLC_len-12));
		arrowLC.graphics.beginFill("purple").setStrokeStyle(1).moveTo(0,-(arrowLC_len-12)).lineTo(10,-(arrowLC_len-12)).lineTo(0,-arrowLC_len).lineTo(-10,-(arrowLC_len-12)).lineTo(0,-(arrowLC_len-12));
		arrowLC.x = diagram_x + 70;
		arrowLC.y = diagram_y + 350;

		if (LC > 0) {
			arrowLC.rotation = 0;
			LCtext2.text = "L        C";
			LCtext2.y = diagram_y + 350 - arrowLC_len + 15;
			LCtext1.y = diagram_y + 350 - arrowLC_len;
		} else {
			arrowLC.rotation = 180; // XL - XC is negative!
			LCtext2.text = "C        L";
			LCtext2.y = diagram_y + 340 + arrowLC_len;
			LCtext1.y = diagram_y + 340 + arrowLC_len - 15;
		}
		LCtext1.x = diagram_x + 0;
		LCtext2.x = diagram_x + 13;

		stage.addChild(arrowLC);
		stage.addChild(LCtext1);
		stage.addChild(LCtext2);

	} else {

		arrowLC.visible = false;
		LCtext1.visible = false;
		LCtext2.visible = false;

	}

	//console.log ('XL-XC=' + LC);




	// Draw Z vector
	var Z = Math.sqrt( Math.pow(R, 2) + Math.pow(LC, 2) );

	if (Z>0) {

		arrowZ.visible = true;
		Ztext1.visible = true;
		Ztext2.visible = true;

		var arrowZ_len = Math.abs(70 * Z / 50);
		// console.log ('arrowZ_len: ' + arrowZ_len);

		// fix low values
		if (arrowZ_len < 20) {
			arrowZ_len = 20;
		}

		arrowZ.graphics.clear().beginStroke("red").setStrokeStyle(5).moveTo(0,0).lineTo(0,-(arrowZ_len-12));
		arrowZ.graphics.beginFill("red").setStrokeStyle(1).moveTo(0,-(arrowZ_len-12)).lineTo(10,-(arrowZ_len-12)).lineTo(0,-arrowZ_len).lineTo(-10,-(arrowZ_len-12)).lineTo(0,-(arrowZ_len-12));
		arrowZ.x = diagram_x + 70;
		arrowZ.y = diagram_y + 350;

		// calcuate phi
		var PHI = Math.atan(LC / R) * 180 / Math.PI;
		//console.log ('phi=' + PHI);

		arrowZ.rotation = 90 - PHI;
		stage.addChild(arrowZ);

		var Zx = 70 + arrowZ_len * Math.cos (PHI * Math.PI / 180);
		var Zy = 350 - arrowZ_len * Math.sin (PHI * Math.PI / 180);

		// Draw Phi angle
		PHIangle.x = diagram_x + 70;
		PHIangle.y = diagram_y + 350;

		PHIangle.graphics.clear().beginFill("#bbbbbb").beginStroke("grey").setStrokeStyle(1).arc(0, 0, 35, 0, -PHI * Math.PI / 180, PHI>0).lineTo(0, 0).closePath();
		stage.addChild(PHIangle);
		stage.setChildIndex(PHIangle, 1);

		// Show/hide Phi angle
		if (R > 25) {
			PHIangle.visible = true;
		} else {
			PHIangle.visible = false;
		}


		// Draw phi text
		PHItext.x = diagram_x + 110;

		var PHIy;
		if (PHI > 0) {
			PHIy = 350 - 40 * Math.sin (PHI * Math.PI / 180);
			// PHItext.y = diagram_y + 350 + (-1 * 18);
			PHItext.y = diagram_y + PHIy;
		} else {
			PHIy = 350 - 12 * Math.sin (PHI * Math.PI / 180);
			// PHItext.y = diagram_y + 350 + (0.4 * 18);
			PHItext.y = diagram_y + PHIy;
		}
		stage.addChild(PHItext);

		// Show/hide Phi text
		if (R > 40 && (PHI > 20 || PHI < -20)) {
			PHItext.visible = true;
		} else {
			PHItext.visible = false;
		}

		// Z dashed lines
		if ( (PHI > 85 && PHI <= 90) || (PHI >= -90 && PHI < -85) || (PHI < 5 && PHI > -5)) {
			// Do not show dashed lines for 90, -90 and 0.
			// Include also very low values +/- 5!
			ZvertDash.visible = false;
			ZhorizDash.visible = false;
		} else {
			ZvertDash.visible = true;
			ZhorizDash.visible = true;

			ZvertDash.graphics.clear().setStrokeDash([10,10]).beginStroke("grey").setStrokeStyle(1).moveTo(Zx, Zy).lineTo(Zx, 350);
			ZvertDash.x = diagram_x + 0;
			ZvertDash.y = diagram_y + 0;
			stage.addChild(ZvertDash);

			ZhorizDash.graphics.clear().setStrokeDash([10,10]).beginStroke("grey").setStrokeStyle(1).moveTo(Zx, Zy).lineTo(70, Zy);
			ZhorizDash.x = diagram_x + 0;
			ZhorizDash.y = diagram_y + 0;
			stage.addChild(ZhorizDash);
		}

		// Z text
		Ztext1.x = diagram_x + Zx + 14;
		Ztext1.y = diagram_y + Zy;
		stage.addChild(Ztext1);

		Ztext2.x = diagram_x + Zx + 26;
		Ztext2.y = diagram_y + Zy + 16;
		stage.addChild(Ztext2);

	} else {
		arrowZ.visible = false;
		Ztext1.visible = false;
		Ztext2.visible = false;
	}


	return true;

}





function update_results() {

	var F, R, L, C, XL, XC, Z, PHI, I;

	F = config.f_value;
	
	R = parseFloat( $("#num_r1").val() );
	L = parseFloat( $("#num_l1").val() );
	C = parseFloat( $("#num_c1").val() );

	// Convert
	L = L / 1000;			// We use mH (mH = 10^-3, μΗ = 10^-6, nH = 10^-9, pH = 10^-12)
	C = C / 1000 / 1000; 	// We use μF (mF = 10^-3, μF = 10^-6, nF = 10^-9, pF = 10^-12)

	// XL
	if (L > 0) {
		XL = 2 * Math.PI * F * L;
	} else {
		XL = 0;
	}

	// XC
	if (C > 0) {
		XC = 1 / (2 * Math.PI * F * C);
	} else {
		XC = 0;
	}

	// set decimal precision to 1 decimal
	// in order to have easier the coordination phenomenon
	XL = XL.toFixed(1);
	XC = XC.toFixed(1);

	$("#result_coordination").hide();
	if ( L!=0 && C!=0 && (XL-XC)==0 ) {
		// Coordination (syntonismos)
		Z = R;
		PHI = 0;
		F = Math.sqrt( 1 / (L*C) ) / 2 * Math.PI;  // New Frequency!
		F = F.toFixed(1);
		$("#result_coordination").show();
		$("#result_coordination").html("Επίτευξη Συντονισμού!");
		console.log ('Coordication frequency ' + F + 'Hz');
	} else if (L==0 && C==0) {
		// Only R in the circuit
		Z = R;
		PHI = 0;
	} else {
		Z = Math.sqrt( Math.pow(R, 2) + Math.pow(XL - XC, 2));
		PHI = Math.atan((XL-XC) / R) * 180 / Math.PI;
	}
	
	I = 230 / Z;	// I = V / R (V=230, R=Zol)

	// set decimal precision
	I = I.toFixed(1);
	R = R.toFixed(1);
	Z = Z.toFixed(1);
	PHI = PHI.toFixed(1);

	$("#ammeter").html( format_number_el(I) + " A");
	$("#result_r").html( format_number_el(R) + " Ω");
	$("#result_xl").html( format_number_el(XL) + " Ω");
	$("#result_xc").html( format_number_el(XC) + " Ω");
	$("#result_z").html( format_number_el(Z) + " Ω");
	$("#result_phi").html( format_number_el(PHI) + "<sup>o</sup>");

	return true;

}


function update_circuit() {

	var R = parseFloat( $("#num_r1").val() );
	var L = parseFloat( $("#num_l1").val() );
	var C = parseFloat( $("#num_c1").val() );

	if (R==0) {
		elementR.visible = false;
	} else {
		elementR.visible = true;
	}

	if (L==0) {
		elementL.visible = false;
	} else {
		elementL.visible = true;
	}

	if (C==0) {
		elementC.visible = false;
	} else {
		elementC.visible = true;
	}

	// Update Diagram
	update_diagram(R, L, C);

	// Update Results
	update_results();

	return true;

}






/*
function d1_r1_changed() {
	var d1 = true;

	if ( $("#switch_d1").prop("checked") ) {
		d1 = true;
	} else {
		d1 = false;
	}
	r1 = parseFloat( $("#num_r1").val() );
	calc_ammeter(d1, r1);
	toggle_switch_d2(d1, r1);
}


// Calculate Amper Meter
function calc_ammeter(d1, r1) {

	var i = 0;

	if (d1==true) {
		if (r1 <= 3900) {
			i = 98.76 - ((r1 - 500) * 0.00036);
		} else {
			i = 97.535 - ((r1 - 3900) * 0.013);
		}
	}

	// Display 2 decimal
	i = Math.round(i*100)/100;
	i = i.toFixed(2);

	// display results
	// console.log(i);
	$("#ammeter").html(i);

	return i;
}


// Calculate Switch D2
function toggle_switch_d2(d1, r1) {

	var status = '';

	if (d1==true && (r1 >= 500 && r1 <=4100)) {
		status = 'closed';
	} else {
		status = 'open';
	}

	// display results
	// console.log(status);
	if (status=='open')	{
		$("#circuit_status").html('Ανοικτό');
	} else {
		$("#circuit_status").html('Κλειστό');
	}
		

	return status;
}


*/

function format_number_el(val) {
	// Get a javascript float number with decimal .
	// Replace decimal . with , and returns a string with the number formated with greek locale
	var num = val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ";"); // convert to string with thousands separator as ;
	num = num.replace(".", ","); // replace decimal separator with ,
	num = num.replace(new RegExp(";", 'g'), "."); // replace thousands separator with .

	return num;
}

function convert_to_number_el(val) {
	// Get a string formated with greek locale (thousands separator as . and decimal separator as ,)
	// and return a javascript float number with decimal .
	var num = val.replace(".", "");  // remove thousands separator
	num = num.replace(",", ".");     // replace decimal separator with .
	num = parseFloat(num);

	return num;
}