// Create Canvas elements



// Initialize Canvas
var canvas = document.getElementById("canvas");
var context = canvas.getContext('2d');
var stage = new createjs.Stage("canvas");

// Circuit Title
var circuit_title = new createjs.Text();
circuit_title.font = "20px Arial";
circuit_title.color = "#003366";
circuit_title.textAlign = "left";
circuit_title.text = "Ηλεκτρικό Κύκλωμα";

circuit_title.x = config.center_x - 410;
circuit_title.y = config.center_y - 300;
stage.addChild(circuit_title);


// Circuit base image
var circuit_img = new Image();
circuit_img.src = 'images/circuit.png';

var circuit = new createjs.Bitmap(circuit_img);
circuit.scaleX = circuit.scaleY = 1;
circuit.x = config.center_x - 410;
circuit.y = config.center_y - 260;

circuit_img.onload = function () {
	stage.addChild(circuit);
	stage.setChildIndex(circuit, 0);
	stage.update();
}

// Element R
var elementR_img = new Image();
elementR_img.src = 'images/element-R.png';

var elementR = new createjs.Bitmap(elementR_img);
elementR.scaleX = elementR.scaleY = 1;
elementR.x = config.center_x - 402;
elementR.y = config.center_y - 155;


elementR_img.onload = function () {
	stage.addChild(elementR);
	stage.setChildIndex(elementR, 1);
	stage.update();
}

// Element L
var elementL_img = new Image();
elementL_img.src = 'images/element-L.png';

var elementL = new createjs.Bitmap(elementL_img);
elementL.scaleX = elementL.scaleY = 1;
elementL.x = config.center_x - 270;
elementL.y = config.center_y - 247;

elementL_img.onload = function () {
	stage.addChild(elementL);
	stage.setChildIndex(elementL, 100);
	stage.update();
}

// Element C
var elementC_img = new Image();
elementC_img.src = 'images/element-C.png';

var elementC = new createjs.Bitmap(elementC_img);
elementC.scaleX = elementL.scaleY = 1;
elementC.x = config.center_x - 127;
elementC.y = config.center_y - 130;

elementC_img.onload = function () {
	stage.addChild(elementC);
	stage.setChildIndex(elementC, 100);
	stage.update();
}





// Align diagram
var diagram_x = config.center_x - 30;
var diagram_y = config.center_y - 330;



// Create X,Y Axes
var x_axis = new createjs.Shape();
x_axis.graphics.beginStroke("black").setStrokeStyle(2).moveTo(0,0).lineTo(418,0);
x_axis.graphics.beginStroke("black").setStrokeStyle(2).moveTo(420,0).lineTo(409,-9);
x_axis.graphics.beginStroke("black").setStrokeStyle(2).moveTo(420,0).lineTo(409,9);
x_axis.x = diagram_x + 0;
x_axis.y = diagram_y + 350;
stage.addChild(x_axis);

xtext = new createjs.Text("x", "24px Arial", "black");
xtext.x = diagram_x + 420;
xtext.y = diagram_y + 350;
stage.addChild(xtext);

var y_axis=new createjs.Shape();
y_axis.graphics.beginStroke("black").setStrokeStyle(2).moveTo(0,0).lineTo(0,623);
y_axis.graphics.beginStroke("black").setStrokeStyle(2).moveTo(0,0).lineTo(9,11).moveTo(0,0).lineTo(-9,11);
y_axis.graphics.beginStroke("black").setStrokeStyle(2).moveTo(0,625).lineTo(9,614).moveTo(0,625).lineTo(-9,614);
y_axis.x = diagram_x + 70;
y_axis.y = diagram_y + 35;
stage.addChild(y_axis);

ytext = new createjs.Text("y", "24px Arial", "black");
ytext.x = diagram_x + 45;
ytext.y = diagram_y + 20;
stage.addChild(ytext);

/*
Otext = new createjs.Text("0", "24px Arial", "black");
Otext.x = diagram_x + 45;
Otext.y = diagram_y + 354;
stage.addChild(Otext);
*/


// Create Phi angle
var PHIangle = new createjs.Shape();

// Create Diagram Arrows
var arrowR = new createjs.Shape();
var arrowL = new createjs.Shape();
var arrowC = new createjs.Shape();
var arrowLC = new createjs.Shape();
var arrowZ = new createjs.Shape();
var ZvertDash = new createjs.Shape();
var ZhorizDash = new createjs.Shape();


// Create Diagram Texts
var Rtext1 = new createjs.Text("R", "20px Arial", "#009900");
var Ltext1 = new createjs.Text("X", "20px Arial", "gold");
var Ltext2 = new createjs.Text("L", "13px Arial", "gold");
var Ctext1 = new createjs.Text("X", "20px Arial", "blue");
var Ctext2 = new createjs.Text("C", "13px Arial", "blue");
var LCtext1 = new createjs.Text("X  - X", "20px Arial", "purple");
var LCtext2 = new createjs.Text("L        C", "13px Arial", "purple");
var Ztext1 = new createjs.Text("Z", "20px Arial", "red");
var Ztext2 = new createjs.Text("ΟΛ", "11px Arial", "red");
var PHItext = new createjs.Text("φ", "13px Arial", "grey");

/*
// R click area
var switch_r_area = new createjs.Shape();
switch_r_area.graphics.beginFill("#ff000010").drawRoundRect(0, 0, 55, 63, 0);
switch_r_area.x = config.center_x - 402;
switch_r_area.y = config.center_y - 155;
switch_r_area.cursor = "pointer"; // show pointer on mouseover
stage.addChild(switch_r_area);
stage.setChildIndex(switch_r_area, 200);

// Enable Mouseover on stage
stage.enableMouseOver();
*/

// Stage update
stage.update();





